% https://www.cpp.edu/~jrfisher/www/prolog_tutorial/pt_framer.html

% η περιοχή Χ είναι γειτονική με τη περιοχή Υ για τον χάρτη Map 
adjacent(X,Y,Map) :- member([X,Y],Map) ; member([Y,X],Map). 

conflict(Map,Coloring) :- 
    member([R1,C],Coloring), 
    member([R2,C],Coloring), 
    adjacent(R1,R2,Map). 

% Για να μην εμφανίζονται οι μεταβλητές που ξεκινούν με _
% set_prolog_flag(toplevel_print_anon, false).

% Είναι οι περιοχές 4 και 2 γειτονικές στο χάρτη [[1,2],[1,3],[1,4],[1,5],[2,3],[2,4],[3,4],[4,5]];
% ?- _Map = [[1,2],[1,3],[1,4],[1,5],[2,3],[2,4],[3,4],[4,5]], adjacent(4, 2, _Map).
% true .

% Είναι οι περιοχές 5 και 2 γειτονικές στο χάρτη [[1,2],[1,3],[1,4],[1,5],[2,3],[2,4],[3,4],[4,5]];
% ?- _Map = [[1,2],[1,3],[1,4],[1,5],[2,3],[2,4],[3,4],[4,5]], adjacent(5, 2, _Map). 
% false.

% Έχει ο χρωματισμός [[5,red],[4,red],[3,blue],[1,blue],[2,yellow]] για το χάρτη [[1,2],[1,3],[1,4],[1,5],[2,3],[2,4],[3,4],[4,5]] σύγκρουση;
% ?- _Map = [[1,2],[1,3],[1,4],[1,5],[2,3],[2,4],[3,4],[4,5]], _Coloring = [[5,red],[4,red],[3,blue],[1,blue],[2,yellow]], conflict(_Map,_Coloring).
% true .

% Έχει ο χρωματισμός [[5,blue],[4,red],[3,yellow],[1,green],[2,blue]] για το χάρτη [[1,2],[1,3],[1,4],[1,5],[2,3],[2,4],[3,4],[4,5]] σύγκρουση;
% ?- _Map = [[1,2],[1,3],[1,4],[1,5],[2,3],[2,4],[3,4],[4,5]], _Coloring = [[5,blue],[4,red],[3,yellow],[1,green],[2,blue]], conflict(_Map,_Coloring).
% false.
