:- use_module(library(clpfd)).

solve(X,Y,Z) :- 
    X in 1..20,
    Y in 1..20,
    Z in 1..20,
    X + Y + Z #= 15,
    X #> Y,
    Z #>= 2 * Y,
    label([X,Y,Z]).

% εναλλακτική λύση
solve2(X,Y,Z) :- 
    Vs = [X,Y,Z], 
    Vs ins 1..20,
    X + Y + Z #= 15,
    X #> Y,
    Z #>= 2 * Y,
    label(Vs), 
    write(Vs),
    nl,
    fail.

% ?- solve(X,Y,Z).
% X = 2,
% Y = 1,
% Z = 12 ;
% X = 3,
% Y = 1,
% Z = 11 ;
% X = 3,
% Y = 2,
% Z = 10 ;
% X = 4,
% Y = 1,
% Z = 10 ;
% X = 4,
% Y = 2,
% Z = 9 ;
% X = 4,
% Y = 3,
% Z = 8 ;
% X = 5,
% Y = 1,
% Z = 9 ;
% X = 5,
% Y = 2,
% Z = 8 ;
% X = 5,
% Y = 3,
% Z = 7 ;
% X = 6,
% Y = 1,
% Z = 8 ;
% X = 6,
% Y = 2,
% Z = 7 ;
% X = Z, Z = 6,
% Y = 3 ;
% X = Z, Z = 7,
% Y = 1 ;
% X = 7,
% Y = 2,
% Z = 6 ;
% X = 8,
% Y = 1,
% Z = 6 ;
% X = 8,
% Y = 2,
% Z = 5 ;
% X = 9,
% Y = 1,
% Z = 5 ;
% X = 9,
% Y = 2,
% Z = 4 ;
% X = 10,
% Y = 1,
% Z = 4 ;
% X = 11,
% Y = 1,
% Z = 3 ;
% X = 12,
% Y = 1,
% Z = 2.

% ?- solve2(X,Y,Z). 
% [2,1,12]
% [3,1,11]
% [3,2,10]
% [4,1,10]
% [4,2,9]
% [4,3,8]
% [5,1,9]
% [5,2,8]
% [5,3,7]
% [6,1,8]
% [6,2,7]
% [6,3,6]
% [7,1,7]
% [7,2,6]
% [8,1,6]
% [8,2,5]
% [9,1,5]
% [9,2,4]
% [10,1,4]
% [11,1,3]
% [12,1,2]
% false.